diff -uNr unrar/makefile.unix unrar/makefile.unix
--- unrar/makefile.unix	1970-01-01 01:00:00.000000000 +0100
+++ unrar/makefile.unix	2008-10-09 15:43:06.000000000 +0200
@@ -0,0 +1,148 @@
+#
+# Makefile for UNIX - unrar
+#
+# Note: you have to 'make clean' before you can build
+#	the sfx module
+#
+
+# Linux using GCC
+#CXX=g++
+#CXXFLAGS=-O2
+DEFINES=-D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE
+STRIP=strip
+DESTDIR=/usr
+
+# Linux using LCC
+#CXX=lcc
+#CXXFLAGS=-O2
+#DEFINES=-D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE
+#STRIP=strip
+#DESTDIR=/usr
+
+# HP UX using aCC
+#CXX=aCC
+#CXXFLAGS=-AA +O2 +Onolimit
+#DEFINES=-D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE
+#STRIP=strip
+#DESTDIR=/usr
+
+# IRIX using GCC
+#CXX=g++
+#CXXFLAGS=-O2 
+#DEFINES=-DBIG_ENDIAN -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_BSD_COMPAT -D_XOPEN_SOURCE -D_XOPEN_SOURCE_EXTENDED=1
+#STRIP=strip
+#DESTDIR=/usr
+
+# IRIX using MIPSPro (experimental)
+#CXX=CC
+#CXXFLAGS=-O2 -mips3 -woff 1234,1156,3284 -LANG:std
+#DEFINES=-DBIG_ENDIAN -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_BSD_COMPAT -DNATIVE_INT64 -DInt64=int64_t
+#STRIP=strip
+#DESTDIR=/usr
+
+# AIX using xlC (IBM VisualAge C++ 5.0)
+#CXX=xlC
+#CXXFLAGS=-O -qinline -qro -qroconst -qmaxmem=16384 -qcpluscmt
+#DEFINES=-D_LARGE_FILES -D_LARGE_FILE_API
+#LIBS=-lbsd
+#STRIP=strip
+#DESTDIR=/usr
+
+# Solaris using CC (SUN Forte Developer 7 C++)
+#CXX=CC
+#CXXFLAGS=-xO2 -xbuiltin=%all -xinline=%auto
+#DEFINES=-DBIG_ENDIAN -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE
+#STRIP=strip
+#DESTDIR=/usr
+
+# Solaris using GCC (optimized for UltraSPARC 1 CPU)
+#CXX=g++
+#CXXFLAGS=-O3 -mcpu=v9 -mtune=ultrasparc -m32
+#DEFINES=-D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE
+#STRIP=/usr/ccs/bin/strip
+#DESTDIR=/usr
+
+# Tru64 5.1B using GCC3
+#CXX=g++
+#CXXFLAGS=-O2 -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_XOPEN_SOURCE=500
+#STRIP=strip
+#LDFLAGS=-rpath /usr/local/gcc/lib
+#DESTDIR=/usr
+
+# Tru64 5.1B using DEC C++
+#CXX=cxx
+#CXXFLAGS=-O4 -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -DNATIVE_INT64 -DInt64=long
+#STRIP=strip
+#LDFLAGS=
+#DESTDIR=/usr
+
+# QNX 6.x using GCC
+#CXX=g++
+#CXXFLAGS=-O2 -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -fexceptions
+#STRIP=strip
+#LDFLAGS=-fexceptions
+#DESTDIR=/usr
+
+# Cross-compile
+# Linux using arm-linux-g++
+#CXX=arm-linux-g++
+#CXXFLAGS=-O2
+#DEFINES=-D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE
+#STRIP=arm-linux-strip
+#LDFLAGS=-static
+#DESTDIR=/usr
+
+##########################
+
+COMPILE=$(CXX) $(CPPFLAGS) $(CXXFLAGS) $(DEFINES)
+LINK=$(CXX)
+
+WHAT=UNRAR
+
+UNRAR_OBJ=filestr.o recvol.o rs.o scantree.o
+LIB_OBJ=filestr.o scantree.o dll.o
+
+OBJECTS=rar.o strlist.o strfn.o pathfn.o int64.o savepos.o global.o file.o filefn.o filcreat.o \
+	archive.o arcread.o unicode.o system.o isnt.o crypt.o crc.o rawread.o encname.o \
+	resource.o match.o timefn.o rdwrfn.o consio.o options.o ulinks.o errhnd.o rarvm.o \
+	rijndael.o getbits.o sha1.o extinfo.o extract.o volume.o list.o find.o unpack.o cmddata.o
+
+.cpp.o:
+	$(COMPILE) -D$(WHAT) -c $<
+
+all:	unrar
+
+install:	install-unrar
+
+uninstall:	uninstall-unrar
+
+clean:
+	@rm -f *.o *.bak *~
+
+unrar:	$(OBJECTS) $(UNRAR_OBJ)
+	@rm -f unrar
+	$(LINK) -o unrar $(LDFLAGS) $(OBJECTS) $(UNRAR_OBJ) $(LIBS)	
+	$(STRIP) unrar
+
+sfx:	WHAT=SFX_MODULE
+sfx:	$(OBJECTS)
+	@rm -f default.sfx
+	$(LINK) -o default.sfx $(LDFLAGS) $(OBJECTS)
+	$(STRIP) default.sfx
+
+lib:	WHAT=RARDLL
+lib:	$(OBJECTS) $(LIB_OBJ)
+	@rm -f libunrar.so
+	$(LINK) -shared -o libunrar.so $(LDFLAGS) $(OBJECTS) $(LIB_OBJ)
+
+install-unrar:
+			install unrar $(DESTDIR)/bin
+
+uninstall-unrar:
+			rm -f $(DESTDIR)/bunrar
+
+install-lib:
+		install libunrar.so $(DESTDIR)/lib
+
+uninstall-lib:
+		rm -f $(DESTDIR)/lib/libunrar.so
diff -uNr unrar/match.cpp unrar/match.cpp
--- unrar/match.cpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/match.cpp	2008-10-24 06:44:47.000000000 +0200
@@ -5,15 +5,15 @@
 
 static int mstricompc(const char *Str1,const char *Str2,bool ForceCase);
 static int mstricompcw(const wchar *Str1,const wchar *Str2,bool ForceCase);
-static int mstrnicompc(const char *Str1,const char *Str2,int N,bool ForceCase);
-static int mstrnicompcw(const wchar *Str1,const wchar *Str2,int N,bool ForceCase);
+static int mstrnicompc(const char *Str1,const char *Str2,size_t N,bool ForceCase);
+static int mstrnicompcw(const wchar *Str1,const wchar *Str2,size_t N,bool ForceCase);
 
 inline uint toupperc(byte ch,bool ForceCase)
 {
   if (ForceCase)
     return(ch);
 #ifdef _WIN_32
-  return((uint)CharUpper((LPTSTR)(ch)));
+  return((uint)(LPARAM)CharUpper((LPTSTR)(ch)));
 #elif defined(_UNIX)
   return(ch);
 #else
@@ -42,7 +42,7 @@
   
   if (CmpPath!=MATCH_NAMES)
   {
-    int WildLength=strlen(Wildcard);
+    size_t WildLength=strlen(Wildcard);
     if (CmpPath!=MATCH_EXACTPATH && mstrnicompc(Wildcard,Name,WildLength,ForceCase)==0)
     {
       char NextCh=Name[WildLength];
@@ -71,8 +71,12 @@
   }
   char *Name1=PointToName(Wildcard);
   char *Name2=PointToName(Name);
+
+  // always return false for RAR temporary files to exclude them
+  // from archiving operations
   if (mstrnicompc("__rar_",Name2,6,false)==0)
     return(false);
+
   return(match(Name1,Name2,ForceCase));
 }
 
@@ -86,7 +90,7 @@
 
   if (CmpPath!=MATCH_NAMES)
   {
-    int WildLength=strlenw(Wildcard);
+    size_t WildLength=strlenw(Wildcard);
     if (CmpPath!=MATCH_EXACTPATH && mstrnicompcw(Wildcard,Name,WildLength,ForceCase)==0)
     {
       wchar NextCh=Name[WildLength];
@@ -113,8 +117,12 @@
   }
   wchar *Name1=PointToName(Wildcard);
   wchar *Name2=PointToName(Name);
+
+  // always return false for RAR temporary files to exclude them
+  // from archiving operations
   if (mstrnicompcw(L"__rar_",Name2,6,false)==0)
     return(false);
+
   return(match(Name1,Name2,ForceCase));
 }
 #endif
@@ -236,7 +244,7 @@
 #endif
 
 
-int mstrnicompc(const char *Str1,const char *Str2,int N,bool ForceCase)
+int mstrnicompc(const char *Str1,const char *Str2,size_t N,bool ForceCase)
 {
   if (ForceCase)
     return(strncmp(Str1,Str2,N));
@@ -249,7 +257,7 @@
 
 
 #ifndef SFX_MODULE
-int mstrnicompcw(const wchar *Str1,const wchar *Str2,int N,bool ForceCase)
+int mstrnicompcw(const wchar *Str1,const wchar *Str2,size_t N,bool ForceCase)
 {
   if (ForceCase)
     return(strncmpw(Str1,Str2,N));
diff -uNr unrar/match.hpp unrar/match.hpp
--- unrar/match.hpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/match.hpp	2008-10-24 06:44:48.000000000 +0200
@@ -1,7 +1,22 @@
 #ifndef _RAR_MATCH_
 #define _RAR_MATCH_
 
-enum {MATCH_NAMES,MATCH_PATH,MATCH_EXACTPATH,MATCH_SUBPATH,MATCH_WILDSUBPATH};
+enum {
+   MATCH_NAMES,        // Compare names only.
+
+   MATCH_PATH,         // Compares names and paths. Both must match exactly.
+                       // Unlike MATCH_EXACTPATH, also matches names if
+                       // mask contains path only and this path is a part
+                       // of name path.
+
+   MATCH_EXACTPATH,    // Compares names and paths. Both must match exactly.
+
+   MATCH_SUBPATH,      // Names must be the same, but path in mask is allowed
+                       // to be only a part of name path.
+
+   MATCH_WILDSUBPATH   // Works as MATCH_SUBPATH if mask contains wildcards
+                       // and as MATCH_PATH otherwise.
+};
 
 #define MATCH_MODEMASK           0x0000ffff
 #define MATCH_FORCECASESENSITIVE 0x80000000
diff -uNr unrar/options.cpp unrar/options.cpp
--- unrar/options.cpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/options.cpp	2008-10-24 06:44:47.000000000 +0200
@@ -16,7 +16,7 @@
 {
   memset(this,0,sizeof(RAROptions));
   WinSize=0x400000;
-  Overwrite=OVERWRITE_ASK;
+  Overwrite=OVERWRITE_DEFAULT;
   Method=3;
   MsgStream=MSG_STDOUT;
   ConvertNames=NAMES_ORIGINALCASE;
diff -uNr unrar/options.hpp unrar/options.hpp
--- unrar/options.hpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/options.hpp	2008-10-24 06:44:48.000000000 +0200
@@ -17,8 +17,13 @@
 };
 enum {NAMES_ORIGINALCASE,NAMES_UPPERCASE,NAMES_LOWERCASE};
 enum MESSAGE_TYPE {MSG_STDOUT,MSG_STDERR,MSG_ERRONLY,MSG_NULL};
+
 enum OVERWRITE_MODE {
-  OVERWRITE_ASK,OVERWRITE_ALL,OVERWRITE_NONE,OVERWRITE_AUTORENAME
+  OVERWRITE_DEFAULT, // ask for extraction, silently overwrite for archiving
+  OVERWRITE_ALL,
+  OVERWRITE_NONE,
+  OVERWRITE_AUTORENAME,
+  OVERWRITE_FORCE_ASK
 };
 
 enum RAR_CHARSET { RCH_DEFAULT=0,RCH_ANSI,RCH_OEM,RCH_UNICODE };
@@ -54,6 +59,7 @@
     RAR_CHARSET CommentCharset;
     RAR_CHARSET FilelistCharset;
     char ArcPath[NM];
+    wchar ArcPathW[NM];
     char Password[MAXPASSWORD];
     bool EncryptHeaders;
     char LogName[NM];
@@ -133,7 +139,7 @@
     wchar DllDestNameW[NM];
     int DllOpMode;
     int DllError;
-    LONG UserData;
+    LPARAM UserData;
     UNRARCALLBACK Callback;
     CHANGEVOLPROC ChangeVolProc;
     PROCESSDATAPROC ProcessDataProc;
diff -uNr unrar/os2ea.cpp unrar/os2ea.cpp
--- unrar/os2ea.cpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/os2ea.cpp	2008-10-24 06:44:47.000000000 +0200
@@ -13,14 +13,14 @@
   if (Arc.HeaderCRC!=Arc.EAHead.HeadCRC)
   {
     Log(Arc.FileName,St(MEABroken),FileName);
-    ErrHandler.SetErrorCode(RAR_CRC_ERROR);
+    ErrHandler.SetErrorCode(CRC_ERROR);
     return;
   }
 
   if (Arc.EAHead.Method<0x31 || Arc.EAHead.Method>0x35 || Arc.EAHead.UnpVer>PACK_VER)
   {
     Log(Arc.FileName,St(MEAUnknHeader),FileName);
-    ErrHandler.SetErrorCode(RAR_WARNING);
+    ErrHandler.SetErrorCode(WARNING);
     return;
   }
 
@@ -46,7 +46,7 @@
   if (Arc.EAHead.EACRC!=~DataIO.UnpFileCRC)
   {
     Log(Arc.FileName,St(MEABroken),FileName);
-    ErrHandler.SetErrorCode(RAR_CRC_ERROR);
+    ErrHandler.SetErrorCode(CRC_ERROR);
     return;
   }
 
@@ -55,7 +55,7 @@
   if (DosSetPathInfo((unsigned char *)FileName,2,&EAOP2,sizeof(EAOP2),0x10)!=0)
   {
     Log(Arc.FileName,St(MCannotSetEA),FileName);
-    ErrHandler.SetErrorCode(RAR_WARNING);
+    ErrHandler.SetErrorCode(WARNING);
   }
   File::SetCloseFileTimeByName(FileName,&Arc.NewLhd.mtime,&Arc.NewLhd.atime);
   mprintf(St(MShowEA));
@@ -86,7 +86,7 @@
   if (DosSetPathInfo((unsigned char *)FileName,2,&EAOP2,sizeof(EAOP2),0x10)!=0)
   {
     Log(Arc.FileName,St(MCannotSetEA),FileName);
-    ErrHandler.SetErrorCode(RAR_WARNING);
+    ErrHandler.SetErrorCode(WARNING);
   }
   File::SetCloseFileTimeByName(FileName,&Arc.NewLhd.mtime,&Arc.NewLhd.atime);
   mprintf(St(MShowEA));
diff -uNr unrar/os.hpp unrar/os.hpp
--- unrar/os.hpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/os.hpp	2008-10-24 06:44:48.000000000 +0200
@@ -33,6 +33,7 @@
 #include <prsht.h>
 
 #ifndef _WIN_CE
+  #include <shellapi.h>
   #include <shlobj.h>
   #include <winioctl.h>
 #endif
@@ -213,7 +214,7 @@
 
 #endif
 
-typedef const char* MSGID;
+  typedef const char* MSGID;
 
 #define safebuf static
 
diff -uNr unrar/pathfn.cpp unrar/pathfn.cpp
--- unrar/pathfn.cpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/pathfn.cpp	2008-10-24 06:44:47.000000000 +0200
@@ -29,6 +29,8 @@
 }
 
 
+
+
 char* ConvertPath(const char *SrcPath,char *DestPath)
 {
   const char *DestPtr=SrcPath;
@@ -325,6 +327,26 @@
 #endif
 
 
+#if defined(_WIN_32) && !defined(_WIN_CE) && !defined(SFX_MODULE)
+void GetRarDataPath(char *Path)
+{
+  *Path=0;
+
+  HKEY hKey;
+  if (RegOpenKeyEx(HKEY_CURRENT_USER,"Software\\WinRAR\\Paths",0,
+                   KEY_QUERY_VALUE,&hKey)==ERROR_SUCCESS)
+  {
+    DWORD DataSize=NM,Type;
+    RegQueryValueEx(hKey,"AppData",0,&Type,(BYTE *)Path,&DataSize);
+    RegCloseKey(hKey);
+  }
+
+  if (*Path==0 || !FileExist(Path))
+    GetAppDataPath(Path);
+}
+#endif
+
+
 #ifndef SFX_MODULE
 bool EnumConfigPaths(char *Path,int Number)
 {
@@ -348,18 +370,16 @@
   RemoveNameFromPath(Path);
   return(true);
 #elif defined(_UNIX)
+  static const char *AltPath[]={
+    "/etc","/etc/rar","/usr/lib","/usr/local/lib","/usr/local/etc"
+  };
   if (Number==0)
   {
     char *EnvStr=getenv("HOME");
-    if (EnvStr==NULL)
-      return(false);
-    strncpy(Path,EnvStr,NM-1);
+    strncpy(Path, (EnvStr==NULL) ? AltPath[0] : EnvStr, NM-1);
     Path[NM-1]=0;
     return(true);
   }
-  static const char *AltPath[]={
-    "/etc","/etc/rar","/usr/lib","/usr/local/lib","/usr/local/etc"
-  };
   Number--;
   if (Number<0 || Number>=sizeof(AltPath)/sizeof(AltPath[0]))
     return(false);
@@ -370,7 +390,7 @@
   if (Number<0 || Number>1)
     return(false);
   if (Number==0)
-    GetAppDataPath(Path);
+    GetRarDataPath(Path);
   else
   {
     GetModuleFileName(NULL,Path,NM);
@@ -388,6 +408,7 @@
 #ifndef SFX_MODULE
 void GetConfigName(const char *Name,char *FullName,bool CheckExist)
 {
+  *FullName=0;
   for (int I=0;EnumConfigPaths(FullName,I);I++)
   {
     AddEndSlash(FullName);
@@ -399,19 +420,29 @@
 #endif
 
 
-// returns a pointer to rightmost digit of volume number
+// Returns a pointer to rightmost digit of volume number.
 char* GetVolNumPart(char *ArcName)
 {
+  // Pointing to last name character.
   char *ChPtr=ArcName+strlen(ArcName)-1;
+
+  // Skipping the archive extension.
   while (!isdigit(*ChPtr) && ChPtr>ArcName)
     ChPtr--;
+
+  // Skipping the numeric part of name.
   char *NumPtr=ChPtr;
   while (isdigit(*NumPtr) && NumPtr>ArcName)
     NumPtr--;
+
+  // Searching for first numeric part in names like name.part##of##.rar.
+  // Stop search on the first dot.
   while (NumPtr>ArcName && *NumPtr!='.')
   {
     if (isdigit(*NumPtr))
     {
+      // Validate the first numeric part only if it has a dot somwhere 
+      // before it.
       char *Dot=strchrd(PointToName(ArcName),'.');
       if (Dot!=NULL && Dot<NumPtr)
         ChPtr=NumPtr;
@@ -423,7 +454,7 @@
 }
 
 
-void NextVolumeName(char *ArcName,bool OldNumbering)
+void NextVolumeName(char *ArcName,wchar *ArcNameW,uint MaxLength,bool OldNumbering)
 {
   char *ChPtr;
   if ((ChPtr=GetExt(ArcName))==NULL)
@@ -469,6 +500,29 @@
           ChPtr--;
         }
     }
+  if (ArcNameW!=NULL && *ArcNameW!=0)
+  {
+    // Copy incremented trailing low ASCII volume name part to Unicode name.
+    // It is simpler than implementing Unicode version of entire function.
+    char *NumPtr=GetVolNumPart(ArcName);
+
+    // moving to first digit in volume number
+    while (NumPtr>ArcName && isdigit(*NumPtr) && isdigit(*(NumPtr-1)))
+      NumPtr--;
+
+    // also copy the first character before volume number,
+    // because it can be changed when going from .r99 to .s00
+    if (NumPtr>ArcName)
+      NumPtr--;
+
+    int CharsToCopy=strlen(ArcName)-(NumPtr-ArcName);
+    int DestPos=strlenw(ArcNameW)-CharsToCopy;
+    if (DestPos>=0)
+    {
+      CharToWide(NumPtr,ArcNameW+DestPos,MaxLength-DestPos-1);
+      ArcNameW[MaxLength-1]=0;
+    }
+  }
 }
 
 
@@ -579,7 +633,22 @@
 {
   char PathOnly[NM];
   GetFilePath(Path,PathOnly,ASIZE(PathOnly));
-  if (IsWildcard(PathOnly))
+  if (IsWildcard(PathOnly,NULL))
+    return(true);
+#if defined(_WIN_32) || defined(_EMX)
+  return(Path[0]=='\\' && Path[1]=='\\' ||
+         IsDiskLetter(Path) && IsPathDiv(Path[2]));
+#else
+  return(IsPathDiv(Path[0]));
+#endif
+}
+
+
+bool IsFullPath(const wchar *Path)
+{
+  wchar PathOnly[NM];
+  GetFilePath(Path,PathOnly,ASIZE(PathOnly));
+  if (IsWildcard(NULL,PathOnly))
     return(true);
 #if defined(_WIN_32) || defined(_EMX)
   return(Path[0]=='\\' && Path[1]=='\\' ||
@@ -597,6 +666,13 @@
 }
 
 
+bool IsDiskLetter(const wchar *Path)
+{
+  int Letter=etoupper(Path[0]);
+  return(Letter>='A' && Letter<='Z' && IsDriveDiv(Path[1]));
+}
+
+
 void GetPathRoot(const char *Path,char *Root)
 {
   *Root=0;
@@ -608,7 +684,7 @@
       const char *Slash=strchr(Path+2,'\\');
       if (Slash!=NULL)
       {
-        int Length;
+        size_t Length;
         if ((Slash=strchr(Slash+1,'\\'))!=NULL)
           Length=Slash-Path+1;
         else
diff -uNr unrar/pathfn.hpp unrar/pathfn.hpp
--- unrar/pathfn.hpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/pathfn.hpp	2008-10-24 06:44:48.000000000 +0200
@@ -24,17 +24,20 @@
 void RemoveNameFromPath(char *Path);
 void RemoveNameFromPath(wchar *Path);
 void GetAppDataPath(char *Path);
+void GetRarDataPath(char *Path);
 bool EnumConfigPaths(char *Path,int Number);
 void GetConfigName(const char *Name,char *FullName,bool CheckExist);
 char* GetVolNumPart(char *ArcName);
-void NextVolumeName(char *ArcName,bool OldNumbering);
+void NextVolumeName(char *ArcName,wchar *ArcNameW,uint MaxLength,bool OldNumbering);
 bool IsNameUsable(const char *Name);
 void MakeNameUsable(char *Name,bool Extended);
 char* UnixSlashToDos(char *SrcName,char *DestName=NULL,uint MaxLength=NM);
 char* DosSlashToUnix(char *SrcName,char *DestName=NULL,uint MaxLength=NM);
 wchar* UnixSlashToDos(wchar *SrcName,wchar *DestName=NULL,uint MaxLength=NM);
 bool IsFullPath(const char *Path);
+bool IsFullPath(const wchar *Path);
 bool IsDiskLetter(const char *Path);
+bool IsDiskLetter(const wchar *Path);
 void GetPathRoot(const char *Path,char *Root);
 int ParseVersionFileName(char *Name,wchar *NameW,bool Truncate);
 char* VolNameToFirstName(const char *VolName,char *FirstName,bool NewNumbering);
diff -uNr unrar/rar.cpp unrar/rar.cpp
--- unrar/rar.cpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/rar.cpp	2008-10-24 06:44:47.000000000 +0200
@@ -118,12 +118,12 @@
 #ifdef ENABLE_BAD_ALLOC
   catch (bad_alloc)
   {
-    ErrHandler.SetErrorCode(RAR_MEMORY_ERROR);
+    ErrHandler.SetErrorCode(MEMORY_ERROR);
   }
 #endif
   catch (...)
   {
-    ErrHandler.SetErrorCode(RAR_FATAL_ERROR);
+    ErrHandler.SetErrorCode(FATAL_ERROR);
   }
 #endif
   File::RemoveCreated();
diff -uNr unrar/rarvm.cpp unrar/rarvm.cpp
--- unrar/rarvm.cpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/rarvm.cpp	2008-10-24 06:44:47.000000000 +0200
@@ -180,6 +180,7 @@
   while (1)
   {
 #ifndef NORARVM
+    // Get addresses to quickly access operands.
     uint *Op1=GetOperand(&Cmd->Op1);
     uint *Op2=GetOperand(&Cmd->Op2);
 #endif
@@ -536,6 +537,7 @@
   InitBitInput();
   memcpy(InBuf,Code,Min(CodeSize,BitInput::MAX_SIZE));
 
+  // Calculate the single byte XOR checksum to check validity of VM code.
   byte XorSum=0;
   for (int I=1;I<CodeSize;I++)
     XorSum^=Code[I];
@@ -543,12 +545,13 @@
   faddbits(8);
 
   Prg->CmdCount=0;
-  if (XorSum==Code[0])
+  if (XorSum==Code[0]) // VM code is valid if equal.
   {
 #ifdef VM_STANDARDFILTERS
     VM_StandardFilters FilterType=IsStandardFilter(Code,CodeSize);
     if (FilterType!=VMSF_NONE)
     {
+      // VM code is found among standard filters.
       Prg->Cmd.Add(1);
       VM_PreparedCommand *CurCmd=&Prg->Cmd[Prg->CmdCount++];
       CurCmd->OpCode=VM_STANDARD;
@@ -562,9 +565,9 @@
     uint DataFlag=fgetbits();
     faddbits(1);
 
-/* Read static data contained in DB operators. This data cannot be changed,
-   it is a part of VM code, not a filter parameter.
-*/
+    // Read static data contained in DB operators. This data cannot be
+    // changed, it is a part of VM code, not a filter parameter.
+
     if (DataFlag&0x8000)
     {
       int DataSize=ReadData(*this)+1;
@@ -603,13 +606,14 @@
       CurCmd->Op1.Addr=CurCmd->Op2.Addr=NULL;
       if (OpNum>0)
       {
-        DecodeArg(CurCmd->Op1,CurCmd->ByteMode);
+        DecodeArg(CurCmd->Op1,CurCmd->ByteMode); // reading the first operand
         if (OpNum==2)
-          DecodeArg(CurCmd->Op2,CurCmd->ByteMode);
+          DecodeArg(CurCmd->Op2,CurCmd->ByteMode); // reading the second operand
         else
         {
           if (CurCmd->Op1.Type==VM_OPINT && (VM_CmdFlags[CurCmd->OpCode]&(VMCF_JUMP|VMCF_PROC)))
           {
+            // Calculating jump distance.
             int Distance=CurCmd->Op1.Data;
             if (Distance>=256)
               Distance-=256;
@@ -632,6 +636,8 @@
       Prg->CmdCount++;
     }
   }
+
+  // Adding RET command at the end of program.
   Prg->Cmd.Add(1);
   VM_PreparedCommand *CurCmd=&Prg->Cmd[Prg->CmdCount++];
   CurCmd->OpCode=VM_RET;
@@ -639,6 +645,11 @@
   CurCmd->Op2.Addr=&CurCmd->Op2.Data;
   CurCmd->Op1.Type=CurCmd->Op2.Type=VM_OPNONE;
 
+  // If operand 'Addr' field has not been set by DecodeArg calls above,
+  // let's set it to point to operand 'Data' field. It is necessary for
+  // VM_OPINT type operands (usual integers) or maybe if something was 
+  // not set properly for other operands. 'Addr' field is required
+  // for quicker addressing of operand data.
   for (int I=0;I<Prg->CmdCount;I++)
   {
     VM_PreparedCommand *Cmd=&Prg->Cmd[I];
@@ -660,31 +671,33 @@
   uint Data=fgetbits();
   if (Data & 0x8000)
   {
-    Op.Type=VM_OPREG;
-    Op.Data=(Data>>12)&7;
-    Op.Addr=&R[Op.Data];
-    faddbits(4);
+    Op.Type=VM_OPREG;     // Operand is register (R[0]..R[7])
+    Op.Data=(Data>>12)&7; // Register number
+    Op.Addr=&R[Op.Data];  // Register address
+    faddbits(4);          // 1 flag bit and 3 register number bits 
   }
   else
     if ((Data & 0xc000)==0)
     {
-      Op.Type=VM_OPINT;
+      Op.Type=VM_OPINT;   // Operand is integer
       if (ByteMode)
       {
-        Op.Data=(Data>>6) & 0xff;
+        Op.Data=(Data>>6) & 0xff;  // Byte integer.
         faddbits(10);
       }
       else
       {
         faddbits(2);
-        Op.Data=ReadData(*this);
+        Op.Data=ReadData(*this);   // 32 bit integer.
       }
     }
     else
     {
+      // Operand is data addressed by register data, base address or both.
       Op.Type=VM_OPREGMEM;
       if ((Data & 0x2000)==0)
       {
+        // Base address is zero, just use the address from register.
         Op.Data=(Data>>10)&7;
         Op.Addr=&R[Op.Data];
         Op.Base=0;
@@ -694,16 +707,18 @@
       {
         if ((Data & 0x1000)==0)
         {
+          // Use both register and base address.
           Op.Data=(Data>>9)&7;
           Op.Addr=&R[Op.Data];
           faddbits(7);
         }
         else
         {
+          // Use base address only. Access memory by fixed address.
           Op.Data=0;
           faddbits(4);
         }
-        Op.Base=ReadData(*this);
+        Op.Base=ReadData(*this); // Read base address.
       }
     }
 }
@@ -761,6 +776,9 @@
   for (int I=0;I<CodeSize;I++)
   {
     VM_PreparedCommand *Cmd=Code+I;
+
+    // Replace universal opcodes with faster byte or word only processing
+    // opcodes.
     switch(Cmd->OpCode)
     {
       case VM_MOV:
@@ -772,6 +790,11 @@
     }
     if ((VM_CmdFlags[Cmd->OpCode] & VMCF_CHFLAGS)==0)
       continue;
+
+    // If we do not have jump commands between the current operation
+    // and next command which will modify processor flags, we can replace
+    // the current command with faster version which does not need to
+    // modify flags.
     bool FlagsRequired=false;
     for (int J=I+1;J<CodeSize;J++)
     {
@@ -784,6 +807,10 @@
       if (Flags & VMCF_CHFLAGS)
         break;
     }
+
+    // Below we'll replace universal opcodes with faster byte or word only 
+    // processing opcodes, which also do not modify processor flags to
+    // provide better performance.
     if (FlagsRequired)
       continue;
     switch(Cmd->OpCode)
@@ -817,7 +844,7 @@
     int Length;
     uint CRC;
     VM_StandardFilters Type;
-  } StdList[]={
+  } static StdList[]={
     53, 0xad576887, VMSF_E8,
     57, 0x3cd7e57e, VMSF_E8E9,
    120, 0x3769893f, VMSF_ITANIUM,
@@ -931,9 +958,8 @@
         if (DataSize>=VM_GLOBALMEMADDR/2)
           break;
 
-// bytes from same channels are grouped to continual data blocks,
-// so we need to place them back to their interleaving positions
-
+        // Bytes from same channels are grouped to continual data blocks,
+        // so we need to place them back to their interleaving positions.
         for (int CurChannel=0;CurChannel<Channels;CurChannel++)
         {
           byte PrevByte=0;
diff -uNr unrar/rdwrfn.cpp unrar/rdwrfn.cpp
--- unrar/rdwrfn.cpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/rdwrfn.cpp	2008-10-24 06:44:47.000000000 +0200
@@ -59,13 +59,13 @@
       RetCode=SrcFile->Read(ReadAddr,ReadSize);
       FileHeader *hd=SubHead!=NULL ? SubHead:&SrcArc->NewLhd;
       if (hd->Flags & LHD_SPLIT_AFTER)
-        PackedCRC=CRC(PackedCRC,ReadAddr,ReadSize);
+        PackedCRC=CRC(PackedCRC,ReadAddr,RetCode);
     }
     CurUnpRead+=RetCode;
     TotalRead+=RetCode;
 #ifndef NOVOLUME
-    // these variable are not used below in NOVOLUME mode, so it is better
-    // to exclude these commands to avoid compiler warnings
+    // These variable are not used in NOVOLUME mode, so it is better
+    // to exclude commands below to avoid compiler warnings.
     ReadAddr+=RetCode;
     Count-=RetCode;
 #endif
@@ -118,8 +118,8 @@
   if (Cmd->DllOpMode!=RAR_SKIP)
   {
     if (Cmd->Callback!=NULL &&
-        Cmd->Callback(UCM_PROCESSDATA,Cmd->UserData,(LONG)Addr,Count)==-1)
-      ErrHandler.Exit(RAR_USER_BREAK);
+        Cmd->Callback(UCM_PROCESSDATA,Cmd->UserData,(LPARAM)Addr,Count)==-1)
+      ErrHandler.Exit(USER_BREAK);
     if (Cmd->ProcessDataProc!=NULL)
     {
 #if defined(_WIN_32) && !defined(_MSC_VER) && !defined(__MINGW32__)
@@ -130,7 +130,7 @@
       _ESP=_EBX;
 #endif
       if (RetCode==0)
-        ErrHandler.Exit(RAR_USER_BREAK);
+        ErrHandler.Exit(USER_BREAK);
     }
   }
 #endif
@@ -169,19 +169,21 @@
 {
   if (ShowProgress && SrcFile!=NULL)
   {
-    Archive *SrcArc=(Archive *)SrcFile;
-    RAROptions *Cmd=SrcArc->GetRAROptions();
     if (TotalArcSize!=0)
+    {
+      // important when processing several archives or multivolume archive
       ArcSize=TotalArcSize;
-    ArcPos+=ProcessedArcSize;
-    if (!SrcArc->Volume)
+      ArcPos+=ProcessedArcSize;
+    }
+
+    Archive *SrcArc=(Archive *)SrcFile;
+    RAROptions *Cmd=SrcArc->GetRAROptions();
+
+    int CurPercent=ToPercent(ArcPos,ArcSize);
+    if (!Cmd->DisablePercentage && CurPercent!=LastPercent)
     {
-      int CurPercent=ToPercent(ArcPos,ArcSize);
-      if (!Cmd->DisablePercentage && CurPercent!=LastPercent)
-      {
-        mprintf("\b\b\b\b%3d%%",CurPercent);
-        LastPercent=CurPercent;
-      }
+      mprintf("\b\b\b\b%3d%%",CurPercent);
+      LastPercent=CurPercent;
     }
   }
 }
diff -uNr unrar/rdwrfn.hpp unrar/rdwrfn.hpp
--- unrar/rdwrfn.hpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/rdwrfn.hpp	2008-10-24 06:44:48.000000000 +0200
@@ -72,7 +72,12 @@
     Int64 TotalPackRead;
     Int64 UnpArcSize;
     Int64 CurPackRead,CurPackWrite,CurUnpRead,CurUnpWrite;
-    Int64 ProcessedArcSize,TotalArcSize;
+
+    // Size of already processed archives.
+    // Used to calculate the total operation progress.
+    Int64 ProcessedArcSize;
+
+    Int64 TotalArcSize;
 
     uint PackFileCRC,UnpFileCRC,PackedCRC;
 
diff -uNr unrar/recvol.cpp unrar/recvol.cpp
--- unrar/recvol.cpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/recvol.cpp	2008-10-24 06:44:48.000000000 +0200
@@ -79,6 +79,11 @@
 #ifndef SILENT
   Int64 RecFileSize=0;
 #endif
+
+#ifndef SILENT
+  mprintf(St(MCalcCRCAllVol));
+#endif
+
   FindFile Find;
   Find.SetMask(RecVolMask);
   struct FindData RecData;
@@ -236,7 +241,7 @@
 #endif
     }
     SrcFile[CurArcNum]=(File*)NewFile;
-    NextVolumeName(ArcName,!NewNumbering);
+    NextVolumeName(ArcName,ArcNameW,ASIZE(ArcName),!NewNumbering);
   }
 
 #ifndef SILENT
diff -uNr unrar/scantree.cpp unrar/scantree.cpp
--- unrar/scantree.cpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/scantree.cpp	2008-10-24 06:44:47.000000000 +0200
@@ -7,6 +7,8 @@
   ScanTree::GetLinks=GetLinks;
   ScanTree::GetDirs=GetDirs;
 
+  ScanEntireDisk=false;
+
   SetAllMaskDepth=0;
   *CurMask=0;
   *CurMaskW=0;
@@ -57,6 +59,7 @@
 
 bool ScanTree::PrepareMasks()
 {
+  ScanEntireDisk=false;
   if (!FileMasks->GetString(CurMask,CurMaskW,sizeof(CurMask)))
     return(false);
   CurMask[ASIZE(CurMask)-1]=0;
@@ -64,6 +67,12 @@
 #ifdef _WIN_32
   UnixSlashToDos(CurMask);
 #endif
+
+  // We wish to scan entire disk if mask like c:\ is specified
+  // regardless of recursion mode. Use c:\*.* mask when need to scan only 
+  // the root directory.
+  ScanEntireDisk=IsDiskLetter(CurMask) && IsPathDiv(CurMask[2]) && CurMask[3]==0;
+
   char *Name=PointToName(CurMask);
   if (*Name==0)
     strcat(CurMask,MASKALL);
@@ -116,7 +125,7 @@
     bool FindCode=!Wildcards && FindFile::FastFind(CurMask,CurMaskW,FindData,GetLinks);
     bool IsDir=FindCode && FindData->IsDir;
     bool SearchAll=!IsDir && (Depth>0 || Recurse==RECURSE_ALWAYS ||
-                   Wildcards && Recurse==RECURSE_WILDCARDS);
+                   Wildcards && Recurse==RECURSE_WILDCARDS || ScanEntireDisk);
     if (Depth==0)
       SearchAllInRoot=SearchAll;
     if (SearchAll || Wildcards)
@@ -234,7 +243,10 @@
     }
     if (GetDirs==SCAN_GETDIRSTWICE &&
         FindFile::FastFind(DirName,DirNameW,FindData,GetLinks) && FindData->IsDir)
+    {
+      FindData->Flags|=FDDF_SECONDDIR;
       return(Error ? SCAN_ERROR:SCAN_SUCCESS);
+    }
     return(Error ? SCAN_ERROR:SCAN_NEXT);
   }
 
diff -uNr unrar/scantree.hpp unrar/scantree.hpp
--- unrar/scantree.hpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/scantree.hpp	2008-10-24 06:44:48.000000000 +0200
@@ -26,6 +26,9 @@
     int GetDirs;
     int Errors;
 
+    // set when processing paths like c:\ (root directory without wildcards)
+    bool ScanEntireDisk;
+
     char CurMask[NM];
     wchar CurMaskW[NM];
     char OrigCurMask[NM];
diff -uNr unrar/strfn.cpp unrar/strfn.cpp
--- unrar/strfn.cpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/strfn.cpp	2008-10-24 06:44:48.000000000 +0200
@@ -86,7 +86,7 @@
 
 char* RemoveEOL(char *Str)
 {
-  for (int I=strlen(Str)-1;I>=0 && (Str[I]=='\r' || Str[I]=='\n' || Str[I]==' ' || Str[I]=='\t');I--)
+  for (int I=(int)strlen(Str)-1;I>=0 && (Str[I]=='\r' || Str[I]=='\n' || Str[I]==' ' || Str[I]=='\t');I--)
     Str[I]=0;
   return(Str);
 }
@@ -94,7 +94,7 @@
 
 char* RemoveLF(char *Str)
 {
-  for (int I=strlen(Str)-1;I>=0 && (Str[I]=='\r' || Str[I]=='\n');I--)
+  for (int I=(int)strlen(Str)-1;I>=0 && (Str[I]=='\r' || Str[I]=='\n');I--)
     Str[I]=0;
   return(Str);
 }
@@ -103,7 +103,8 @@
 unsigned int loctolower(byte ch)
 {
 #ifdef _WIN_32
-  return((int)CharLower((LPTSTR)ch));
+  // convert to LPARAM first to avoid a warning in 64 bit mode
+  return((int)(LPARAM)CharLower((LPTSTR)ch));
 #else
   return(tolower(ch));
 #endif
@@ -113,7 +114,8 @@
 unsigned int loctoupper(byte ch)
 {
 #ifdef _WIN_32
-  return((int)CharUpper((LPTSTR)ch));
+  // convert to LPARAM first to avoid a warning in 64 bit mode
+  return((int)(LPARAM)CharUpper((LPTSTR)ch));
 #else
   return(toupper(ch));
 #endif
diff -uNr unrar/strlist.cpp unrar/strlist.cpp
--- unrar/strlist.cpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/strlist.cpp	2008-10-24 06:44:48.000000000 +0200
@@ -31,7 +31,7 @@
 unsigned int StringList::AddString(const char *Str,const wchar *StrW)
 {
   int PrevSize=StringData.Size();
-  StringData.Add(strlen(Str)+1);
+  StringData.Add((int)(strlen(Str)+1));
   strcpy(&StringData[PrevSize],Str);
   if (StrW!=NULL && *StrW!=0)
   {
diff -uNr unrar/timefn.cpp unrar/timefn.cpp
--- unrar/timefn.cpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/timefn.cpp	2008-10-24 06:44:48.000000000 +0200
@@ -248,7 +248,6 @@
 #endif
 
 
-#ifndef SFX_MODULE
 void RarTime::SetCurrentTime()
 {
 #ifdef _WIN_32
@@ -263,7 +262,6 @@
   *this=st;
 #endif
 }
-#endif
 
 
 #if !defined(SFX_MODULE) && !defined(_WIN_CE)
diff -uNr unrar/ulinks.cpp unrar/ulinks.cpp
--- unrar/ulinks.cpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/ulinks.cpp	2008-10-24 06:44:48.000000000 +0200
@@ -20,7 +20,7 @@
         else
         {
           Log(Arc.FileName,St(MErrCreateLnk),DestName);
-          ErrHandler.SetErrorCode(RAR_WARNING);
+          ErrHandler.SetErrorCode(WARNING);
         }
     }
     int NameSize=Min(DataSize,strlen(FileName));
